package br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.tokenization;

import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.MathExpressionParser;
import br.ufes.inf.decisionelement.wheelreinventions.positionalcollections.Tuple;
import java.util.List;

/*
 * Copyright 2020 sfner.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * No docstring set.
 */
public abstract class OperatorExpressionParser extends MathExpressionParser<Character> {
    public OperatorExpressionParser() {
        super();
    }
    public OperatorExpressionParser(Character c) {
        super(c);
    }
    @Override
    protected boolean getCharsSequenceSpans() {
        return false;
    }
    @Override
    protected int getConsumedPrecedingTokens() {
        return 1;
    }
    @Override
    protected int getConsumedSuccedingTokens() {
        return 1;
    }
    @Override
    protected boolean getIsConsumable() {
        return true;
    }
    abstract OperatorExpressionParser construct(Character c);
    @Override
    protected Tuple<MathExpressionParser<?>, String> tryTokenization(String expression) {
        final var dt = this.attemptDefaultTokenization(expression);
        if (dt == null) {
            return null;
        } else {
            return new Tuple<>(construct(dt.first.charAt(0)), dt.second);
        }
    }
    @Override
    protected Tuple<List<MathExpressionParser<?>>, Integer> parseTokens(List<MathExpressionParser<?>> tokens, int i) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
