/*
 * Copyright 2020 sfner.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.tokenization;

import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.MathExpressionParser;
import br.ufes.inf.decisionelement.wheelreinventions.positionalcollections.Tuple;
import java.util.List;

/**
 * No docstring set.
 */
public class ParenthesisExpressionParser extends MathExpressionParser<Character> {
    public ParenthesisExpressionParser() {
        super(null);
    }
    public ParenthesisExpressionParser(Character t) {
        super(t);
    }

    @Override
    protected boolean getCharsSequenceSpans() {
        return false;
    }

    @Override
    protected char[] getRecognizedChars() {
        return new char[]{'(', ')'};
    }

    @Override
    protected int getConsumedPrecedingTokens() {
        return 0;
    }

    @Override
    protected int getConsumedSuccedingTokens() {
        return -1;
    }

    @Override
    protected boolean getIsConsumable() {
        return true;
    }

    @Override
    protected Tuple<MathExpressionParser<?>, String> tryTokenization(String expression) {
        final var dt = this.attemptDefaultTokenization(expression);
        if (dt == null) {
            return null;
        } else {
            return new Tuple<>(new ParenthesisExpressionParser(dt.first.charAt(0)), dt.second);
        }
    }

    @Override
    protected Tuple<List<MathExpressionParser<?>>, Integer> parseTokens(List<MathExpressionParser<?>> tokens, int i) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
